<?php
class FrmMolliePaymentSettingsController{

    public static function load_hooks(){
        add_action('frm_add_settings_section', 'FrmMolliePaymentSettingsController::add_settings_section'); // global settings
        add_action('frm_after_duplicate_form', 'FrmMolliePaymentSettingsController::duplicate', 15, 2);
        add_action('frm_registered_form_actions', 'FrmMolliePaymentSettingsController::register_actions');
        
    }

    public static function add_settings_section($sections){
        $sections['mollie'] = array('class' => 'FrmMolliePaymentSettingsController', 'function' => 'route');
        return $sections;
    }
    
    public static function add_payment_options($sections){
        $sections['mollie'] = array('class' => 'FrmMolliePaymentSettingsController', 'function' => 'payment_options');
        return $sections;
    }
    
    public static function payment_options($values){
        if(isset($values['id'])){
            $form_fields = FrmField::getAll("fi.form_id='$values[id]' and fi.type not in ('divider', 'html', 'break', 'captcha', 'rte', 'form')", ' ORDER BY field_order');
        }
        $hide_mollie = $values['mollie'] ? '' : 'style="display:none;"';
        
        $show_amount = ($values['mollie_amount'] == '') ? false : true;
        
        include(FrmMolliePaymentsController::path() .'/views/settings/payment_options.php');
    }
    
    public static function add_logic_row(){
        $form_id = (int)$_POST['form_id'];
        $meta_name = $_POST['meta_name'];
        $hide_field = '';
        
        $mollie_list = array('hide_field' => array(), 'hide_field_cond' => array($meta_name => '=='), 'hide_opt' => array());
        self::include_logic_row($meta_name, $form_id, $mollie_list);
        
        die();
    }
    
    public static function include_logic_row($meta_name, $form_id, $values) {
        if ( !is_callable('FrmMollieProFormsController::include_logic_row') ) {
            return;
        }
        
        FrmProFormsController::include_logic_row(array(
            'meta_name' => $meta_name,
            'condition' => array(
                'hide_field'    => ( isset($values['hide_field']) && isset($values['hide_field'][$meta_name]) ) ? $values['hide_field'][$meta_name] : '',
                'hide_field_cond' => ( isset($values['hide_field_cond']) && isset($values['hide_field_cond'][$meta_name]) ) ? $values['hide_field_cond'][$meta_name] : '',
                'hide_opt'      => ( isset($values['hide_opt']) && isset($values['hide_opt'][$meta_name]) ) ? $values['hide_opt'][$meta_name] : '',
            ),
            'type' => 'mollie',
            'showlast' => '.frm_add_mollie_logic',
            'key' => 'mollie',
            'form_id' => $form_id,
            'id' => 'frm_logic_mollie_'. $meta_name,
            'names' => array(
                'hide_field'    => 'options[mollie_list][hide_field][]',
                'hide_field_cond' => 'options[mollie_list][hide_field_cond][]',
                'hide_opt'      => 'options[mollie_list][hide_opt][]',
            ),
        ));
    }
        
    public static function display_form($errors=array(), $message=''){
        $options = get_option( TWMOLLIE_WOO_PRODUCT_ID );


        $frm_mollie_settings = new FrmMolliePaymentSettings();
        require(FrmMolliePaymentsController::path() .'/views/settings/form.php');
    }

    /**
     *
     */
    public static function process_form(){
        $frm_mollie_settings = new FrmMolliePaymentSettings();

        //$errors = $frm_mollie_settings->validate($_POST,array());
        $errors = array();
        $frm_mollie_settings->update($_POST);

        if( empty($errors) ){
            $frm_mollie_settings->store();

            $license_options = get_option( TWMOLLIE_WOO_PRODUCT_ID );
            $license_options['email'] = $_POST['frm_pay_teowin_email'] ;
            $license_options['key'] = $_POST['frm_pay_teowin_license'];

            update_option( TWMOLLIE_WOO_PRODUCT_ID , $license_options);

            $message = __('Instellingen opgeslagen', 'frmmollie');
        }

        //build the request query
        $args = array(
            'woo_sl_action'         => 'activate',
            'licence_key'           => $_POST['frm_pay_teowin_license'],
            'product_unique_id'     => TWMOLLIE_WOO_PRODUCT_ID,
            'domain'                => TWMOLLIE_WOO_INSTANCE
        );
        $request_uri    = TWMOLLIE_WOO_APP_API_URL . '?' . http_build_query( $args , '', '&');
        $data           = wp_remote_get( $request_uri );

        //log if debug
        If (defined('WP_DEBUG') &&  WP_DEBUG    === TRUE)
        {
            TWMOLLIE_WOO::log_data("------\nArguments:");
            TWMOLLIE_WOO::log_data($args);

            TWMOLLIE_WOO::log_data("\nResponse Body:");
            TWMOLLIE_WOO::log_data($data['body']);
            TWMOLLIE_WOO::log_data("\nResponse Server Response:");
            TWMOLLIE_WOO::log_data($data['response']);
        }

        if(is_wp_error( $data ) || $data['response']['code'] != 200)
        {
           // $slt_form_submit_messages[] .= __('There was a problem connecting to ', 'frmmollie') . TWMOLLIE_WOO_APP_API_URL;
            $message .= __('There was a problem connecting to ', 'frmmollie') . TWMOLLIE_WOO_APP_API_URL;
            return;
        }

        $response_block = json_decode($data['body']);

        //retrieve the last message within the $response_block

        $response_block = $response_block[count($response_block) - 1];
        $response = $response_block->message;

        if(isset($response_block->status))
        {
            if($response_block->status == 'success' && $response_block->status_code == 's101')
            {
                //the license is active and the software is active
            //    $slt_form_submit_messages[] = $response_block->message;

                $message .= ' - ' . __('Licentie geactiveerd. ', 'frmmollie');
                //save the license
                $license_options['key']          = $_POST['frm_pay_teowin_license'];
                $license_options['last_check']   = time();

                update_site_option(TWMOLLIE_WOO_PRODUCT_ID, $license_options);
            }

            else //if message code is e104  force de-activation
                if ($response_block->status_code == 'e002' || $response_block->status_code == 'e104')
                {
                    $license_options = get_site_option(TWMOLLIE_WOO_PRODUCT_ID);

                    //save the license
                    $license_options['key']          = '';
                    $license_options['last_check']   = time();

                    update_site_option(TWMOLLIE_WOO_PRODUCT_ID, $license_options);

                    $message .= ' ' .  __('There was a problem connecting to ', 'frmmollie');
                }
                else
                {
                    $slt_form_submit_messages[] = __('There was a problem deactivating the licence: ', 'frmmollie') . $response_block->message;

                    return;
                }
        }
        else
        {
            $slt_form_submit_messages[] = __('There was a problem with the data block received from ' . TWMOLLIE_WOO_APP_API_URL, 'frmmollie');
            return;
        }
      /*  try{
            $license_manager = new Teowin_License_Manager_Client(
                '368',
                'Mollie Payments voor Formidable Pro',
                'teowin_nl',
                'https://www.teowin.nl/api/license-manager/v1',
                'plugin',
                __FILE__
            );

            $license_manager->get_license_info();
        }
        catch( Exception $error ) {

        };
      */
    //   $license_data = get_option(TWMOLLIE_WOO_PRODUCT_ID);

        self::display_form($errors, $message);
    }

    public static function route(){
        $action = isset($_REQUEST['frm_action']) ? 'frm_action' : 'action';
        $action = FrmAppHelper::get_param($action);
        if($action == 'process-form')
            return self::process_form();
        else
            return self::display_form();
    }
    
    // switch field keys/ids after form is duplicated
    public static function duplicate($id, $values) {
        if ( is_callable( 'FrmProFieldsHelper::switch_field_ids' ) ) {
            // don't switch IDs unless running Formidabe version that does
            return;
        }
        
        $form = FrmForm::getOne($id);
        $new_opts = $values['options'] = $form->options;
        unset($form);
        
        if ( !isset($values['options']['mollie_item_name']) || empty($values['options']['mollie_item_name']) ) {
            // don't continue if there aren't mollie settings to switch
            return;
        }
        
        global $frm_duplicate_ids;
        
        if ( is_numeric($new_opts['mollie_amount_field']) && isset($frm_duplicate_ids[$new_opts['mollie_amount_field']]) ) {
            $new_opts['mollie_amount_field'] = $frm_duplicate_ids[$new_opts['mollie_amount_field']];
        }
        
        $new_opts['mollie_item_name'] = FrmProFieldsHelper::switch_field_ids($new_opts['mollie_item_name']);
        
        // switch conditional logic
        if ( is_array($new_opts['mollie_list']) && isset($new_opts['mollie_list']['hide_field']) ) {
            foreach ( (array) $new_opts['mollie_list']['hide_field'] as $ck => $cv ) {
                if ( is_numeric($cv) && isset($frm_duplicate_ids[$cv]) ) {
                    $new_opts['mollie_list']['hide_field'][$ck] = $frm_duplicate_ids[$cv];
                }
                
                unset($ck, $cv);
            }
        }
        
        if ( $new_opts != $values['options'] ) {
            global $wpdb;
            $wpdb->update($wpdb->prefix .'frm_forms', array('options' => maybe_serialize($new_opts)), array('id' => $id));
        }
    }

    public static function register_actions($actions) {
        $actions['mollie'] = 'FrmMolliePaymentAction';
        return $actions;
    }

}