<?php
/*
Plugin Name: Formidable Mollie Payment connector
Description: Handle Payments through the Dutch Mollie payment gateway. Deze update verplaatst de plugin naar teowin-software.nl
Version: 3.0.1
Plugin URI: https://www.teowin-software.nl/winkel/
Author URI: https://teowin-software.nl
Author: Teo Super - Teowin.nl
Text Domain: TeowinMollie
*/

/* De code van deze plugin is beschikbaar onder de GPL licentie. Voor het recht op updates
 * en support wordt een jaarlijkse bijdrage gevraagd. Het recht op support vervalt wanneer
 * de code van deze plugin gewijzigd wordt, wanneer er functionaliteit aan wordt toegevoegd
 * of uit wordt verwijderd en wanneer de functionaliteit voor registratie, registratiecontrole
 * en/of automatische updates uit de code verwijderd worden en wanneer deze code geheel of
 * gedeeltelijk voor anderen toegankelijk is of door anderen gebruikt wordt dan de oorspronkelijke
 * licentiehouder.
 * 
 * Het recht op updates vervalt eveneens wanneer de plugin op meer dan het toegestaan aantal
 * websites geinstalleerd/gebruikt wordt.
 * 
 * Licenties zijn op naam gesteld, strikt persoonlijk en niet overdraagbaar (wel via ons!)
 * 
 * Installeren en gebruiken van deze plugin of enig deel daarvan is geheel voor eigen risico.
 * De auteur van deze plugin is niet aansprakelijk voor schade ontstaan door direct of indirect
 * gebruik van deze code. 
 * 
 */

 // If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

include( dirname(__FILE__) . '/include/license_params.php'  );

include(TWMOLLIE_WOO_PATH . '/class.wooslt.php');
include(TWMOLLIE_WOO_PATH . '/class.licence.php');
include(TWMOLLIE_WOO_PATH . '/class.options.php');
include(TWMOLLIE_WOO_PATH . '/class.updater.php');

function frm_mollie_forms_autoloader($class_name) {
    // Only load FrmMolliePayment classes here
    if ( ! preg_match('/^FrmMolliePayment.+$/', $class_name) ) {
        return;
    }

    $filepath = dirname(__FILE__);

    if ( preg_match('/^.+Helper$/', $class_name) ) {
        $filepath .= '/helpers';
    } else if ( preg_match('/^.+Controller$/', $class_name) ) {
        $filepath .= '/controllers';
    } else {
        $filepath .= '/models';
    }

    $filepath .= '/'. $class_name .'.php';

    if ( file_exists($filepath) ) {
        include($filepath);
    }
}

// if __autoload is active, put it on the spl_autoload stack
if ( is_array(spl_autoload_functions()) && in_array('__autoload', spl_autoload_functions()) ) {
    spl_autoload_register('__autoload');
}

// Add the autoloader
spl_autoload_register('frm_mollie_forms_autoloader');

FrmMolliePaymentsController::load_hooks();
FrmMolliePaymentSettingsController::load_hooks();
// TeoS 03-08-2018
// FrmMolliePaymentsFormFieldsController::load_hooks();

function run_twmollie() {

    global $TWMOLLIE;
    $TWMOLLIE = new TWMOLLIE_WOO();
}
run_twmollie();





