<?php

class FrmMolliePaymentDb {
   
    var $payments;

    function FrmPaymentDb(){
        global $wpdb;
        $this->payments = $wpdb->prefix . 'frm_payments';
    }

    function upgrade($old_db_version=false){
        global $wpdb; 
        
        $db_version = FrmMolliePaymentsController::$db_version; //$db_version is the version of the database we're moving to
        $db_opt_name = FrmMolliePaymentsController::$db_opt_name;
        
        if(!$old_db_version)
            $old_db_version = get_option($db_opt_name);

        if ($old_db_version == false){
            $old_db_version = -1;
        }

        if ($db_version != $old_db_version){
            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

            $charset_collate = '';
            if( $wpdb->has_cap( 'collation' ) ){
                if( !empty($wpdb->charset) )
                    $charset_collate = "DEFAULT CHARACTER SET $wpdb->charset";
                if( !empty($wpdb->collate) )
                    $charset_collate .= " COLLATE $wpdb->collate";
            }

            $this->payments = $wpdb->prefix . 'frm_payments';

            /* Create/Upgrade Payments Table */
            $sql = "CREATE TABLE {$this->payments} (
                    id int(11) NOT NULL auto_increment,
                    meta_value longtext default NULL,
                    receipt_id varchar(32) default NULL,
                    item_id int(11) NOT NULL,
                    amount decimal(12,2) NOT NULL default '0.00',
                    completed smallint(6) default '0',
                    begin_date date NOT NULL,
                    expire_date date default NULL,
                    paysys varchar(255) default NULL,                    
                    created_at datetime NOT NULL,
                    PRIMARY KEY  (id),
                    KEY item_id (item_id)
                  ) {$charset_collate} ; ";

            dbDelta($sql);


            /***** SAVE DB VERSION *****/
            update_option($db_opt_name, $db_version);
        }

    }

}